package collector

import (
	"context"
)

type AiCollector interface {
	GetResourceStats(ctx context.Context) (*ResourceStats, error)
	GetDatasetsSpecs(ctx context.Context) ([]*DatasetsSpecs, error)
	GetAlgorithms(ctx context.Context) ([]*Algorithm, error)
	GetTrainingTaskLog(ctx context.Context, taskId string, instanceNum string) (string, error)
	GetTrainingTask(ctx context.Context, taskId string) (*Task, error)
	DownloadAlgorithmCode(ctx context.Context, resourceType string, card string, taskType string, dataset string, algorithm string) (string, error)
	UploadAlgorithmCode(ctx context.Context, resourceType string, card string, taskType string, dataset string, algorithm string, code string) error
	GetComputeCards(ctx context.Context) ([]string, error)
	GetUserBalance(ctx context.Context) (float64, error)
}

type ResourceStats struct {
	ClusterId     string
	Name          string
	CpuCoreAvail  int64
	CpuCoreTotal  int64
	MemAvail      float64
	MemTotal      float64
	DiskAvail     float64
	DiskTotal     float64
	GpuAvail      int64
	GpuTotal      int64
	CardsAvail    []*Card
	CpuCoreHours  float64
	Balance       float64
	TaskCompleted int64
}

type Card struct {
	Platform   string
	Type       string
	Name       string
	TOpsAtFp16 float64
	CardHours  float64
	CardNum    int32
}

type DatasetsSpecs struct {
	Name string
	Size string
}

type Algorithm struct {
	Name     string
	Platform string
	TaskType string
}

type Task struct {
	Id     string
	Start  string
	End    string
	Status string
}
